    include \masm32\include\masm32rt.inc
    .data
    buffer db 64 dup (0)

    consts  real8 1.0      ,1024.0 ,1048576.0,1073741824.0,1099511627776.0,1125899906842624.0,1152921504606846976.0
    names   db    'b',0,0,0,'KiB',0,'MiB',0,  'GiB',0,     'TiB',0,        'PiB',0,           'EiB',0
    hundred real8 100.0
    
    .code
; 
start:  
        mov eax,05e15000h
        mov edx,48h
        call num2kibmib
        mov edi,edx
        lea ebx,names[ebx*4]
        print str$(eax),"."
        print str$(edi)," "
        print ebx,13,10
    inkey "Press any key to exit..."
    exit
; 

num2kibmib:
    push esi
    push edi
    push eax    ;dummy for control word
    
    mov esi,eax ;copy the original number
    mov edi,edx ; ...
    sub ecx,ecx ;shift count
    
    finit
    fstcw [esp]
    or dword ptr [esp],0400h ;don't round up else 99.99 becomes 100
    fldcw [esp]
    
    sub ebx,ebx ;index into consts/names

    ;get the whole part first
l0:     test edx,edx
        jnz l1
        cmp eax,1024
        jb l2
l1:     shrd eax,edx,10
        shr edx,10
        inc ebx
        add ecx,5
        jmp l0
l2:     ;eax=0..1023
        ;edx=0
        ;ebx=index
        ;ecx=shifts/2
         push eax ;save whole part

      ;get whole part
      shld edx,eax,cl
      shl eax,cl
      shld edx,eax,cl
      shl eax,cl

      ;now get remainder
      sub esi,eax
      sbb edi,edx

      ;divide remainder by consts
      push edi
      push esi
      fild QWORD PTR [esp]
      fld QWORD PTR [consts+ebx*8]
      fdiv

      ;now multiply remainder by 100 to get 2 digits
      fld QWORD PTR hundred
      fmul
      fistp QWORD PTR [esp]
      
      pop edx   ;remainder*100 e.g. EDX=50 means .50
      pop eax   ;high part of QWORD should be 0, discard
      pop eax   ;whole part
      pop edi   ;control word, discard
      pop edi
      pop esi
      ret       ;return EAX=whole, EDX=decimal, EBX=index of Kib/etc string
                ;number is EAX.EDX [names+EBX*4]

        align 16

end start
 